﻿;***************************
;  Include External Files  *
;*******************************************************************************
#include 'Aut2Exe\Include\Constants.au3'
#include 'Aut2Exe\Include\GUIConstantsEx.au3'
#include 'Aut2Exe\Include\StaticConstants.au3'
#include 'Aut2Exe\Include\EditConstants.au3'
#include 'Aut2Exe\Include\WindowsConstants.au3'
#include 'Aut2Exe\Include\ListViewConstants.au3'
#Include 'Aut2Exe\Include\WinAPI.au3'
#Include 'Aut2Exe\Include\GDIPlus.au3'
#include 'Aut2Exe\Include\Misc.au3'
#include 'Aut2Exe\Include\GuiListView.au3'


; include our re-branding info and other global variables
#include 'InstantSupportDefs.au3'


;***********************
;  Set Script Options  *
;*******************************************************************************
Opt('GUIOnEventMode', 1)     ; Enable our event handlers
Opt("WinTitleMatchMode", 3)  ; Exact Window Title Match only
Opt('TrayOnEventMode', 1)    ; Enable our Tray event handlers
Opt('TrayMenuMode', 3)       ; Create the Tray icon, No default tray menu items (ie. "Script Paused/Exit" will not be shown), Auto-Checking is off.
;Opt('MustDeclareVars', 1)    ; All variables must be pre-declared with Dim, Local or Global before they can be used


;***********************************
;  Global Constants and Variables  *
;*******************************************************************************
Global $TempConnectId = $ConnectId  ; Initial value in Connection ID input dialog
$ConnectId = Number($ConnectId)  ; Ignore any non-numeric ID's

Global $TempPath = @TempDir & '\' & $ShortName & '_Temp_Files'  ; Set our temp working directory.

Global $StaffIndex = -1  ; Index to selected staff member in list

Global $ServerStarted = False  ; Global Flag to indicate VNC Server state, (used in doGuiClose() and the background loop)

Global $WindowHidden = False  ; Global Flag to indicate wether or not the application window is visible

Global $ManualConnect = False  ; Global Flag to indicate if a manual connection has been either made or attempted. This is used by the Connection Retry code to continue connecting for $ConnectTimeout secs

Global $StaffListId = 0    ; ID for Staff List View
Global $StaffPanelId = 0   ; ID for Opaque Background panel for the Staff List View
Global $StaffBorderId = 0  ; ID for 1 pixel wide left-hand border for Staff List View control

Global $InstallItem
Global $RestoreItem
Global $ConnectItem
Global $ExitItem


;******************************
;  Check for Other Instances  *
;*******************************************************************************
If $PinWindow Then
 If _Singleton($LongName, 0) = 0 Then Exit  ; Exit without a warning dialog if pinned, (so that the warning dialog won't be hidden behind the previous instance's pinned window)
Else
	If _Singleton($LongName, 1) = 0 Then
		Msgbox(0, 'Warning', $LongName & ' is already running')  ; Display a warning dialog if not pinned, (warning dialog won't be hidden behind the previous instance's pinned window)
		Exit
	EndIf
EndIf


;********************************************
;  Register Windows Message Event Handlers  *
;*******************************************************************************
If $ShowID Then GUIRegisterMsg($WM_PAINT, "doPaintText")  ; Register the Windows Paint message, (to repaint the Connection ID text)


;**************
;  Functions  *
;*******************************************************************************
Func _DeleteTemp($iDelay = 5)
	Local $sCmdFile

	FileDelete(@TempDir & '\scratch.bat')

	$sCmdFile = 'PING -n ' & $iDelay & ' 127.0.0.1 > nul' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\cad.exe"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\logo.jpg"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\' & $ShortName & 'Server.exe"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\' & $ShortName & 'ServiceInstaller.exe"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\schook.dll"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\rc4.key"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\MSRC4Plugin.dsm"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\ultravnc.ini"' & @CRLF _
			& 'DEL /F /Q "' & $TempPath & '\chunkvnc.ini"' & @CRLF _
			& 'RMDIR /Q "' & $TempPath & '"' & @CRLF _
			& 'DEL "' & @TempDir & '\scratch.bat"'

	FileWrite(@TempDir & "\scratch.bat", $sCmdFile)

	Run( @TempDir & "\scratch.bat", @TempDir, @SW_HIDE )
EndFunc

Func DrawConnectionId()  ; Show Connection ID
    Local $hDC, $hGraphic, $hBrush, $hFormat, $hFamily, $hFont, $tLayout, $aInfo

	If Not $ShowID Then Return

	If $ConnectIdType = $ConnectIdList And $StaffIndex >= 0 Then
		$ConnectIdDraw = $StaffList[$StaffIndex][1]
	Else
		$ConnectIdDraw = $ConnectId
	EndIf

	If $ConnectIdDraw = 0  Then Return

	; Get DC of GUI
	$hDC  = _WinAPI_GetWindowDC($InstantSupport)

	; Start up GDI+ library
	_GDIPlus_Startup()

	$hGraphic = _GDIPlus_GraphicsCreateFromHDC($hDC)
	$hBrush = _GDIPlus_BrushCreateSolid(0xFF000000 + $IdFontColor)
	$hFormat = _GDIPlus_StringFormatCreate()
	$hFamily = _GDIPlus_FontFamilyCreate($IdFont)
	$hFont = _GDIPlus_FontCreate($hFamily, $IdFontSize, $IdFontStyle, 2)

	$tLayout = _GDIPlus_RectFCreate(0, 0, $GuiWidth, $IdHeight)

	$aInfo = _GDIPlus_GraphicsMeasureString ($hGraphic, 'ID = ' & $ConnectIdDraw, $hFont, $tLayout, $hFormat)
	$tLayout = $aInfo[0]

    $W = DllStructGetData($tLayout, 3)
    $H = DllStructGetData($tLayout, 4)
	DllStructSetData($tLayout, 1, ($GuiWidth - $W)/2)
	DllStructSetData($tLayout, 2,  $LogoHeight + ($GuiHeight - $LogoHeight - $H)/2 + $IdFontSize/2)

	_GDIPlus_GraphicsDrawStringEx($hGraphic, 'ID = ' & $ConnectIdDraw, $hFont, $tLayout, $hFormat, $hBrush)

	; Clean up resources
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_GraphicsDispose($hGraphic)

	; Shut down GDI+ library
	_GDIPlus_ShutDown()
EndFunc

Func ShowHideWindow($Show, $ShowTip=True)
	If $Show Then
		GuiSetState(@SW_SHOW)
		TrayItemSetText($RestoreItem, 'Hide Window')
	Else
		GuiSetState(@SW_HIDE)
		TrayItemSetText($RestoreItem, 'Show Window')
		If $ShowTip Then TrayTip($LongName, 'Click the Tray Icon to Show Window or use the Tray Popup Menu', 5, 1)
	EndIf

	$WindowHidden = Not $Show
EndFunc

Func DisableUAC($Disable)  ; Disable/Restore UAC prompt dialog setting
	$Result = 1

	$Key = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System"
	$Value = "ConsentPromptBehaviorAdmin"
	$Type = "REG_DWORD"

	$RegData = RegRead($Key, $Value)
	If @Error Then Return False ; Key doesn't exist, (probably not Vista or Windows 7)

	If $Disable Then
		$Result = IniWrite($TempPath & '\chunkvnc.ini', 'UAC', 'Prompt', $RegData)        ; Store original UAC setting, (so that it can be restored later)
		If $Result = 1 And $RegData <> 0 Then $Result = RegWrite($Key, $Value, $Type, 0)  ; Disable the UAC prompt dialog, (if were able to store original UAC setting and it requires changing)
	Else
		$RestoreData = IniRead($TempPath & '\chunkvnc.ini', 'UAC', 'Prompt', '')
		If $RestoreData = '' Then Return False  ; Ini value doesn't exist and therefore has never been previously disabled
		If $RestoreData <> $RegData Then $Result = RegWrite($Key, $Value, $Type, $RestoreData)  ; Restore the UAC prompt dialog setting, (if it requires changing)
	EndIf

	If $Result = 0 Then Return False  ; Error: failed to do task
	Return True
EndFunc


;*******************
;  Event Handlers  *
;*******************************************************************************
Func doUnPinWindow()
	If $PinWindow Then
		WinSetOnTop($LongName, '', 0)  ; Un-Pin the Window from the top of the Z-Order
		$PinWindow = False
		HotKeySet($UnPinKeyCode)  ; Disable HotKey
	EndIf
EndFunc

Func doPaintText($hWnd, $Msg)
	DrawConnectionId()
	Return $GUI_RUNDEFMSG  ; Proceed the default Autoit3 internal message commands
EndFunc

Func doLogoClicked()
	ShellExecute('http://' & $WebURL)
EndFunc

Func doGuiClose()
	If $PinWindow Then WinSetOnTop($LongName, '', 0)  ; Un-Pin Window from top of Z-Order (to allow message boxes to display)

	If $ConnectTimeout > 0 And $ConnectTimer > $ConnectTimeout * 1000 Or MsgBox(4, 'Close ' & $LongName, 'Are you sure you want to close ' & $LongName & '?' & @CRLF & 'If you do, no one will be able to connect to you.') = 6 Then
		; Kill the server
		If $ServerStarted Then
			; Allow viewer to disconnect to prevent schook.dll locking.
			MsgBox(0, 'Information', 'Please click OK and wait 15 seconds to allow ' & $LongName & ' to close correctly.' & @CRLF & 'Any currently connected Remote Support technicians should also close their Viewer now.', 15)

			ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-kill')
			; Remove files after server closes.
			ProcessWaitClose($ShortName & 'Server.exe', 30)
		ElseIf $ConnectTimeout > 0 And $ConnectTimer > $ConnectTimeout * 1000 Then
			MsgBox(0, 'Connection Timeout', 'Closing Remote Support in 5 seconds', 5)
		EndIf


		_DeleteTemp()

		DisableUAC(False)  ; Restore the UAC prompt dialog setting

		Exit
	Else
		If $PinWindow Then WinSetOnTop($LongName, '', 1)  ; Re-Pin Window to the top of the Z-Order
	EndIf
EndFunc

Func doListClicked()
	$StaffListItem = GUICtrlRead($StaffListId)

	If $StaffListItem <> 0 Then
		$StaffIndices = _GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($StaffListId), True)
		If $StaffIndices[0] <> 0 Then
			$StaffIndex = $StaffIndices[1]
			GUICtrlSetState($BtnCon, $GUI_ENABLE) ; Enable the Connect button after a technician is selected
		EndIf
	EndIf
EndFunc


Func doConnect()
	$PID = ProcessExists($ShortName & 'Server.exe')  ; Will return the PID or 0 if the process isn't found.

	If $ServerStarted Then
		If $PID = 0 Then
			$ServerStarted = False
		Else
			GUICtrlSetCursor($StaffListId, 15)
			GUICtrlSetCursor($StaffBorderId, 15)
			GUICtrlSetCursor($StaffPanelId, 15)
			GUICtrlSetCursor($BtnExit, 15)
			GUICtrlSetCursor($BtnWeb, 15)
			GUICtrlSetCursor($BtnCon, 15)
			GUICtrlSetCursor($LogoPic, 15)

			ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-kill')

			If ProcessWaitClose($ShortName & 'Server.exe', 30) = 0 Then
				MsgBox(0, 'Disconnection Error', 'Unable to close connection with Remote Support')
			Else
				$ServerStarted = False
			EndIf

			GUICtrlSetCursor($StaffListId, 0)
			GUICtrlSetCursor($StaffBorderId, -1)
			GUICtrlSetCursor($StaffPanelId, -1)
			GUICtrlSetCursor($BtnExit, 0)
			GUICtrlSetCursor($BtnWeb, 0)
			GUICtrlSetCursor($BtnCon, 0)
			GUICtrlSetCursor($LogoPic, 9)
		EndIf

		$ManualConnect = False  ; Used by the Connection Retry code
	Else
		If $PID = 0 Then
			If $ConnectIdType = $ConnectIdList And $StaffIndex >= 0 Then
				ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-autoreconnect ID:' & $StaffList[$StaffIndex][1] & ' -connect ' & $RepeaterAddress & ' -run')
			ElseIf $ConnectId <> 0 And $ConnectId <> '' Then
				ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-autoreconnect ID:' & $ConnectId & ' -connect ' & $RepeaterAddress & ' -run')
			Else
				Return
			EndIf

			If @error Then
				If $ConnectTimeout = 0 Then
					MsgBox(0, 'Connection Error', 'Unable to connect to Remote Support')
				Else
					TrayTip('Establishing Connection...', 'If ' & $LongName & ' is unable to connect within ' & $ConnectTimeout & ' seconds it will automatically exit and uninstall itself', 5, 1)
				EndIf
			Else
				$ServerStarted = True
		        TrayTip($LongName, 'Connection successful', 5, 1)
			EndIf
		Else
			$ServerStarted = True
		EndIf

		$ManualConnect = True  ; Used by the Connection Retry code
	EndIf

	If $ServerStarted Then
		GUICtrlSetData($BtnCon, 'Disconnect')
		TrayItemSetText($ConnectItem, 'Disconnect')
		If $HideOnConnect Then ShowHideWindow(False, False)
	Else
		GUICtrlSetData($BtnCon, 'Connect')
		TrayItemSetText($ConnectItem, 'Connect')
	EndIf

	_WinAPI_SetFocus(GUICtrlGetHandle($StaffListId))  ; Set Focus back to Staff List View
EndFunc

Func doServiceInstall()
	$RandConnectId = Random($LowerLimit, $UpperLimit, 1)  ; Generate a random Connection ID number for the Service

	If MsgBox(4, $LongName & ' Service Installation','The currently running ' & $LongName & ' session must first be closed.' & @CRLF & 'Are you sure you want to close ' & $LongName & '?') = 6 Then

		; Allow viewer to disconnect to prevent schook.dll locking.
		MsgBox(0, 'Information', 'Please click OK and wait 15 seconds to allow ' & $LongName & ' to close correctly.' & @CRLF & 'Any currently connected Remote Support technicians should also close their Viewer now.', 15)

		; Configure ultravnc.ini
		IniWrite($TempPath & "\ultravnc.ini", "admin", "service_commandline", '-autoreconnect ID:' & $RandConnectId & ' -connect ' & $RepeaterAddress)

		; Configure chunkvnc.ini
		IniWrite($TempPath & '\chunkvnc.ini', 'ChunkVNC', 'Path', @ProgramFilesDir & '\' & $LongName)
		IniWrite($TempPath & '\chunkvnc.ini', 'ChunkVNC', 'ID', $RandConnectId)

		; Exit the server.
		ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-kill')

		If @error Then
			MsgBox(0, 'Remote Support Service', 'Error - Unable to install Remote Support Service')
		Else
			; Run installer after the server exits.
			ProcessWaitClose($ShortName & 'Server.exe', 30)

			ShellExecute($TempPath & '\' & $ShortName & 'ServiceInstaller.exe')

			DisableUAC(False)  ; Restore the UAC prompt dialog setting

			If @error Then
				MsgBox(0, 'Remote Support Service', 'Error - Unable to install Remote Support Service')
			Else
				MsgBox(0, 'Remote Support Service', 'Remote Support service installed successfully' & @CRLF & 'ID = ' & $RandConnectId & @CRLF & 'Please record this ID to use for future connections')
			EndIf

			Exit
		EndIf
	EndIf
EndFunc

Func doGuiShowHide()
	ShowHideWindow($WindowHidden)
EndFunc


;**********************
;  Extract the Files  *
;*******************************************************************************
; Remove any leftovers.
DirRemove($TempPath, 1)

; Extract everything. (Note: Files need to be extracted before creating the GUI so that the Logo image can be added)
DirCreate($TempPath)
FileInstall('InstantSupport_Files\cad.exe', $TempPath & '\cad.exe', 1)
FileInstall('InstantSupport_Files\logo.jpg', $TempPath & '\logo.jpg', 1)
FileInstall('InstantSupport_Files\winvnc.exe', $TempPath & '\' & $ShortName & 'Server.exe', 1)
FileInstall('InstantSupport_Files\InstantSupportServiceInstaller.exe', $TempPath & '\' & $ShortName & 'ServiceInstaller.exe', 1)
FileInstall('InstantSupport_Files\schook.dll', $TempPath & '\schook.dll', 1)
FileInstall('InstantSupport_Files\rc4.key', $TempPath & '\rc4.key', 1)
FileInstall('InstantSupport_Files\MSRC4Plugin.dsm', $TempPath & '\MSRC4Plugin.dsm', 1)
FileInstall('InstantSupport_Files\ultravnc.ini', $TempPath & '\ultravnc.ini', 1)
FileInstall('InstantSupport_Files\chunkvnc.ini', $TempPath & '\chunkvnc.ini', 1)


;*******************
;  Create the GUI  *
;*******************************************************************************
$GuiStyles = BitOR($WS_POPUP, $WS_CLIPSIBLINGS, $WS_CLIPCHILDREN)
If $ShowTitleBar Then $GuiStyles = BitOR($GuiStyles, $WS_SYSMENU, $WS_CAPTION)

Global $InstantSupport = GUICreate($LongName, $GuiWidth, $GuiHeight, -1, -1, $GuiStyles) ;, $WS_EX_LAYERED)

GUISetBkColor($BackgroundColor)

; User-defined Controls
; <<<<<<<<<<<<<<< START >>>>>>>>>>>>>>>

If $StaffList <> 0 Then
	$StaffPanelId = GUICtrlCreateGraphic($StaffListLeft, $StaffListTop, $StaffListWidth, $StaffListHeight)  ; Opaque Background panel for the Staff List View
	GUICtrlSetBkColor(-1, 0xFFFFFFFF)
	GUICtrlSetColor(-1, 0xFFFFFFFF)

	$StaffBorderId = GUICtrlCreateLabel('', $StaffListLeft-1, $StaffListTop, 1, $StaffListHeight)  ; Hack to draw a 1 pixel wide left-hand border for Staff List View control, (Need to find a better way to do this)
	GUICtrlSetColor($StaffBorderId, 0x00000000)
	GUICtrlSetBkColor($StaffBorderId, 0x00000000)

	$StaffListId = GUICtrlCreateListView('Staff List', $StaffListLeft, $StaffListTop, $StaffListWidth, $StaffListHeight, BitOR($LVS_NOCOLUMNHEADER, $LVS_NOSORTHEADER, $LVS_REPORT, $LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_FLATSB))  ; Note: For some reason this requires some text in the column header or the rest of the text won't display
EndIf

If $StaffListId <> 0 Then
	GuiCtrlSetState($StaffListId, $GUI_ONTOP)
	GUICtrlSetBkColor($StaffListId, 0x00FFFFFF)
	GUICtrlSetBkColor($StaffListId, $GUI_BKCOLOR_LV_ALTERNATE)  ; Set Staff ListView rows to alternate the colors
	GUICtrlSetFont($StaffListId, 10, 800, 0, "Trebuchet MS")
	GUICtrlSetCursor ($StaffListId, 0)
	GUICtrlSetTip ($StaffListId, 'Select a technician and click the "Connect" button')

	For $i = 0 to UBound($StaffList) - 1
		GUICtrlCreateListViewItem($StaffList[$i][0], $StaffListId)
		GUICtrlSetOnEvent(-1, 'doListClicked')
		If Int($i / 2) * 2 <> $i Then GUICtrlSetBkColor(-1, 0x00C1D3FF)
	Next

	_GUICtrlListView_SetColumnWidth ($StaffListId, 0, $LVSCW_AUTOSIZE_USEHEADER)  ; Resize the column to the full width of the List View control
EndIf

; Draw Buttons
If $ShowExitButton Then
	Global $BtnExit = GUICtrlCreateButton('Exit', $ExitButtonLeft, $ExitButtonTop, 56, 32)
	GUICtrlSetColor($BtnExit, 0x00000000)
	GUICtrlSetFont($BtnExit, 16, 800, 0, "Trebuchet MS")
	GUICtrlSetCursor ($BtnExit, 0)
	GUICtrlSetTip ($BtnExit, 'Close all connections and exit the ' & $LongName & ' application')
	GUICtrlSetOnEvent($BtnExit, 'doGuiClose')
EndIf

If $ShowHelpButton Then
	Global $BtnWeb = GUICtrlCreateButton('Help', $HelpButtonLeft, $HelpButtonTop, 56, 32)
	GUICtrlSetColor($BtnWeb, 0x00000000)
	GUICtrlSetFont($BtnWeb, 16, 800, 0, "Trebuchet MS")
	GUICtrlSetCursor ($BtnWeb, 0)
	GUICtrlSetTip ($BtnWeb, 'Visit the ' & $LongName & ' website')
	GUICtrlSetOnEvent($BtnWeb, 'doLogoClicked')
EndIf

If $ShowConnectButton And $AutoConnect = False Then
	Global $BtnCon = GUICtrlCreateButton('Connect', $ConnectButtonLeft, $ConnectButtonTop, 120, 32)
	GUICtrlSetColor($BtnCon, 0x00E20A17)
	GUICtrlSetFont($BtnCon, 16, 800, 0, "Trebuchet MS")
	GUICtrlSetCursor ($BtnCon, 0)
	GUICtrlSetTip ($BtnCon, 'Connect to the technician currently selected in the list')
	GUICtrlSetOnEvent($BtnCon, 'doConnect')
	GUICtrlSetState($BtnCon, $GUI_DISABLE) ; Initially disable the Connect button until a technician is selected
EndIf

; User-defined Controls
; <<<<<<<<<<<<<<< END >>>>>>>>>>>>>>>

; Draw Logo Image
$LogoExStyle = -1
If Not $ShowTitleBar Then $LogoExStyle = $GUI_WS_EX_PARENTDRAG

Global $LogoPic = GUICtrlCreatePic($TempPath & '\logo.jpg', $LogoLeft, $LogoTop, $LogoWidth, $LogoHeight, BitOR($SS_NOTIFY, $WS_CLIPSIBLINGS), $LogoExStyle)

; Only allow Logo clicking if explicitly enabled and Window has a titlebar and border
If $ShowTitleBar Then
	If $AllowLogoClick And $WebURL <> '' Then
		GUICtrlSetOnEvent($LogoPic, 'doLogoClicked')
		GUICtrlSetCursor($LogoPic, 0)
		GUICtrlSetTip($LogoPic, 'Click here to open the ' & $BrandName & ' website')
	EndIf
Else
;	GuiCtrlSetState($LogoPic, $GUI_DISABLE)  ; Disable Image so that controls may be "overlapped" and the image used as a background (Note: This prevents the Paerent Drag functionality from working)
	GUICtrlSetCursor($LogoPic, 9)
EndIf

; Show Connection ID
;$ConnectIdLabel = GUICtrlCreateLabel('ID = ' & $ConnectId, 0, $LogoHeight, $GuiWidth, $IdHeight, $SS_CENTER)
;GUICtrlSetFont(-1, $IdFontSize, 800, 0, 'Arial Black', 2)
;GUICtrlSetColor(-1, $IdFontColor)
;GUICtrlSetBkColor(-1, $IdBackgroundColor)

GUISetState(@SW_SHOW)  ; Show the GUI

If $ConnectId <> 0 Then DrawConnectionId()  ; Display the Connection ID text, (must do this after showing GUI)

If $PinWindow Then
	WinSetOnTop($LongName, '', 1)              ; Pin the Window to the top of the Z-Order
	HotKeySet($UnPinKeyCode, 'doUnPinWindow')  ; eg. Type [CTRL]U to Un-Pin window
EndIf                                          ; (Note: I tried using a double-mouse click on the logo for this but failed miserably. You can read all about it here: http://www.autoitscript.com/forum/index.php?showtopic=115553)

GUISetOnEvent($GUI_EVENT_CLOSE, 'doGuiClose')


;*************************
;  Create the Tray Menu  *
;*******************************************************************************
TraySetClick(16)    ; Only secondary mouse button will show the tray menu.

TraySetOnEvent($TRAY_EVENT_PRIMARYUP, 'doGuiShowHide')  ; Show Window on Tray Icon Click

$InstallItem = TrayCreateItem('Install ' & StringReplace($LongName, '&', '&&') & ' Service')  ; Replace all "&" characters with "&&" so that they will appear inthe tray menu
TrayItemSetOnEvent($InstallItem, 'doServiceInstall')

TrayCreateItem('')  ; Menu divider

If $HideOnConnect Then
	$RestoreItem = TrayCreateItem('Hide Window')
	TrayItemSetOnEvent($RestoreItem, 'doGuiShowHide')
EndIf

$ConnectItem = TrayCreateItem('Connect')
TrayItemSetOnEvent($ConnectItem, 'doConnect')

$ExitItem = TrayCreateItem('Exit')
TrayItemSetOnEvent($ExitItem, 'doGuiClose')

TraySetToolTip($LongName)

TraySetState()  ; Show the tray icon


;*****************************************
;  Main Application and Background Loop  *
;*******************************************************************************
; Read the address of the repeater from our settings file.
$RepeaterAddress = IniRead($TempPath & '\chunkvnc.ini', 'Repeater', 'Address', '')

DisableUAC(True)  ; Disable the UAC prompt dialog, (should only work if you have administrator privileges, but should save you clicking some buttons if you do)

$ConnectTimer = 0
$StartTime = 0
If $ConnectTimeout > 0 Then $StartTime = TimerInit()  ; Start Connection Timeout Counter

; Background Loop
While True
	; Close any windows firewall messages that popup. The windows firewall doesn't block outgoing connections anyways.
	if WinExists('Windows Security Alert') then WinClose('Windows Security Alert')

	If $ConnectId = 0 And Not $ConnectIdType = $ConnectIdList Then
		$TempConnectId = InputBox('Enter Your Connection ID', 'Connection ID:', $TempConnectId, '', 220, 40)

		if (@Error) Then doGuiClose()  ; Close the app if user cancels

		$ConnectId = Number($TempConnectId)
		If $ConnectId = 0 Or $ConnectId < $LowerLimit Or $ConnectId > $UpperLimit Then
			$ConnectId = 0
			MsgBox(0, 'Error', 'You must enter a numeric Connection ID between ' & $LowerLimit & ' and ' & $UpperLimit)
		EndIf

;		If $ConnectId <> 0 Then GUICtrlSetData($ConnectIdLabel, 'ID = ' & $ConnectId)
		If $ConnectId <> 0 Then DrawConnectionId()  ; Display the  Connection ID text
	EndIf

	; Automatically start the server and make a reverse connection to the repeater.
	If $AutoConnect Or $ManualConnect Then
		If Not $ServerStarted And $ConnectId <> 0 And $ConnectId <> '' Then
			If $StaffIndex >= 0 Then
				ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-autoreconnect ID:' & $StaffList[$StaffIndex][1] & ' -connect ' & $RepeaterAddress & ' -run')
				If Not @error Then $ServerStarted = True
			Else
				If $ConnectId <> 0 And $ConnectId <> '' Then
					ShellExecute($TempPath & '\' & $ShortName & 'Server.exe', '-autoreconnect ID:' & $ConnectId & ' -connect ' & $RepeaterAddress & ' -run')
					If Not @error Then $ServerStarted = True
				EndIf
		    EndIf
		EndIf
	EndIf

	Sleep(100)

	; Get Server Process ID if it exists
	$PID = ProcessExists($ShortName & 'Server.exe')

	; Check to see if server has started unexpectedly
	If $PID <> 0 And Not $ServerStarted Then
		$ServerStarted = True
		GUICtrlSetData($BtnCon, 'Disconnect')
		TrayItemSetText($ConnectItem, 'Disconnect')
		If $HideOnConnect Then ShowHideWindow(False)
	EndIf

	; Check to see if server has stopped unexpectedly
	If $PID = 0 And $ServerStarted Then
		$ServerStarted = False
		GUICtrlSetData($BtnCon, 'Connect')
		TrayItemSetText($ConnectItem, 'Connect')
	EndIf

	If ($AutoConnect Or $ManualConnect) And Not $ServerStarted And $ConnectTimeout > 0 Then
		$ConnectTimer = TimerDiff($StartTime)
		If $ConnectTimer > $ConnectTimeout * 1000 Then doGuiClose()
	EndIf
WEnd
