#RequireAdmin

#include "Aut2Exe\Include\ButtonConstants.au3"
#include "Aut2Exe\Include\EditConstants.au3"
#include "Aut2Exe\Include\GUIConstantsEx.au3"
#include "Aut2Exe\Include\WindowsConstants.au3"

; include our re-branding info and other global variables
#include "InstantSupportDefs.au3"

; Read settings file.
$RepeaterList = IniRead( @ScriptDir & "\settings.ini", "ChunkViewer", "List", "" )
$ListMax = IniRead( @ScriptDir & "\settings.ini", "ChunkViewer", "ListMax", "" )

$Form1 = GUICreate($LongName & " - Compiler", 466, 114, -1, -1, BitOR($WS_SYSMENU,$WS_CAPTION,$WS_POPUP,$WS_CLIPSIBLINGS))
GUISetBkColor(0xFFFFFF)

$BtnCompile = GUICtrlCreateButton("Compile!", 360, 8, 97, 97)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
GUICtrlSetCursor (-1, 0)
GUICtrlSetTip (-1, 'Click here to compile the ' & $LongName & ' Single-Click application')

$LabelRepeaterAddress = GUICtrlCreateLabel("Repeater:", 8, 12, 81, 24)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")

$InputRepeaterAddress = GUICtrlCreateInput($RepeaterUrl, 99, 8, 255, 32)
GUICtrlSetFont(-1, 14, 800, 0, "MS Sans Serif")
GUICtrlSetTip (-1, 'Enter the external address of the VNC Repeater Server')

$Group1 = GUICtrlCreateGroup("VNC Ports", 8, 48, 345, 57)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")

$LabelServer = GUICtrlCreateLabel("Server:", 32, 72, 63, 24)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")

$InputServerPort = GUICtrlCreateInput(String($ServerPort), 104, 72, 49, 24)
GUICtrlSetTip (-1, 'Enter the external port of the VNC Server')

$LabelRepeater = GUICtrlCreateLabel("Repeater:", 188, 72, 81, 24)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")

$InputRepeaterPort = GUICtrlCreateInput(String($RepeaterPort), 280, 72, 49, 24)
GUICtrlSetTip (-1, 'Enter the external port of the VNC Repeater Server')

GUICtrlCreateGroup("", -99, -99, 1, 1)

GUISetState(@SW_SHOW)


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

		Case $BtnCompile
			GUICtrlSetCursor ($Form1, 15)
			GUICtrlSetCursor ($BtnCompile, 15)

			; Check if encryption key exists, if it doesn't create one.
			If Not FileExists( @ScriptDir & "\Viewer\Bin\rc4.key" ) Then

				GenerateKey()

			Else

				If Not $KeepExistingRc4 And MsgBox( 4, "Information", "\Viewer\Bin\rc4.key exists, keep the current encryption key?" ) = 7 Then GenerateKey()

			EndIf

			; Copy encryption key to server directory.
			FileCopy( @ScriptDir & "\Viewer\Bin\rc4.key", @ScriptDir & "\SRC\InstantSupport_Files\rc4.key", 1 )

			; Setup source files with the repeaters address.
			$RepeaterAddress = GUICtrlRead( $InputRepeaterAddress )
			$ServerPortStr = GUICtrlRead( $InputServerPort )
			$RepeaterPortStr = GUICtrlRead( $InputRepeaterPort )
			IniWrite( @ScriptDir & "\Viewer\Bin\chunkviewer.ini", "Repeater", "Address", $RepeaterAddress & ":" & $ServerPortStr )
			IniWrite( @ScriptDir & "\SRC\InstantSupport_Files\chunkvnc.ini", "Repeater", "Address", $RepeaterAddress & ":" & $RepeaterPortStr )

			; Compile Instant Support Service Installer
			ShellExecuteWait( "SRC\Aut2Exe\Aut2Exe.exe", "/in SRC\InstantSupportServiceInstaller.au3 /out SRC\InstantSupport_Files\InstantSupportServiceInstaller.exe /icon SRC\InstantSupport_Files\" & $InstallerIcon & ".ico", @ScriptDir )

			; Compile Instant Support Server
			ShellExecuteWait( "SRC\Aut2Exe\Aut2Exe.exe", "/in SRC\InstantSupport.au3 /out " & $ShortName & ".exe /icon SRC\InstantSupport_Files\" & $ServerIcon & ".ico", @ScriptDir )

			; Compile InstantSupportViewer.exe
			ShellExecuteWait( "SRC\Aut2Exe\Aut2Exe.exe", "/in SRC\InstantSupportViewer.au3 /out Viewer\InstantSupportViewer.exe /icon SRC\InstantSupport_Files\" & $ViewerIcon & ".ico", @ScriptDir )

			MsgBox( 0, "Information", $LongName & " Compilation Complete." )

			Exit

	EndSwitch

WEnd

Func GenerateKey()

	; Remove uvnc settings.
	#region --- ScriptWriter generated code Start ---
	Opt("WinWaitDelay",100)
	Opt("WinTitleMatchMode",4)
	Opt("WinDetectHiddenText",1)
	Opt("MouseCoordMode",0)
	Run( @ScriptDir & '\Viewer\Bin\vncviewer.exe',@ScriptDir & '\Viewer\Bin')
	WinWait("Ultr@VNC Viewer - Connection 1.0.8.2","( host:display or ho")
	If Not WinActive("Ultr@VNC Viewer - Connection 1.0.8.2","( host:display or ho") Then WinActivate("Ultr@VNC Viewer - Connection 1.0.8.2","( host:display or ho")
	WinWaitActive("Ultr@VNC Viewer - Connection 1.0.8.2","( host:display or ho")
	Send("{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{ENTER}{ALTDOWN}{F4}{ALTUP}")
	#endregion --- ScriptWriter generated code End ---

	; Generate Key
	#region --- ScriptWriter generated code Start ---
	Opt("WinWaitDelay",100)
	Opt("WinTitleMatchMode",4)
	Opt("WinDetectHiddenText",1)
	Opt("MouseCoordMode",0)
	Run( @ScriptDir & '\Viewer\Bin\vncviewer.exe',@ScriptDir & '\Viewer\Bin')
	WinWait("Ultr@VNC Viewer - Connection 1.0.8.2","")
	If Not WinActive("Ultr@VNC Viewer - Connection 1.0.8.2","") Then WinActivate("Ultr@VNC Viewer - Connection 1.0.8.2","")
	WinWaitActive("Ultr@VNC Viewer - Connection 1.0.8.2","")
	Send("{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{SPACE}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{TAB}{ENTER}")
	WinWait("MS RC4 Encryption Plugin Configuration","")
	If Not WinActive("MS RC4 Encryption Plugin Configuration","") Then WinActivate("MS RC4 Encryption Plugin Configuration","")
	WinWaitActive("MS RC4 Encryption Plugin Configuration","")
	Send("{TAB}{TAB}{TAB}rc4.key{SHIFTDOWN}{TAB}{SHIFTUP}{ENTER}")
	WinWait("Ultr@VNC Viewer - Connection 1.0.8.2","")
	If Not WinActive("Ultr@VNC Viewer - Connection 1.0.8.2","") Then WinActivate("Ultr@VNC Viewer - Connection 1.0.8.2","")
	WinWaitActive("Ultr@VNC Viewer - Connection 1.0.8.2","")
	Send("{ALTDOWN}{F4}{ALTUP}")
	#endregion --- ScriptWriter generated code End ---

EndFunc

