#RequireAdmin

; include our re-branding info and other global variables
#include "InstantSupportDefs.au3"

$ChunkVNCInstalled = IniRead( @ScriptDir & "\chunkvnc.ini", "ChunkVNC", "Installed", "" )
$ChunkVNCPath = IniRead( @ScriptDir & "\chunkvnc.ini", "ChunkVNC", "Path", "" )
$ChunkVNCID = IniRead( @ScriptDir & "\chunkvnc.ini", "ChunkVNC", "ID", "" )

If $ChunkVNCInstalled = 0 Then

	; Copy files.
	FileCopy( @ScriptDir & "\*.*", $ChunkVNCPath & '\', 9)

	; Configure chunkvnc.ini
	IniWrite( $ChunkVNCPath & "\chunkvnc.ini", "ChunkVNC", "Installed", 1 )

	; Create uninstall link.
	FileCreateShortcut( $ChunkVNCPath & '\' & $ShortName & 'ServiceInstaller.exe', @DesktopCommonDir & '\Uninstall ' & $LongName & ' Service.lnk')

	; Install service.
	ShellExecute( $ChunkVNCPath & "\" & $ShortName & "Server.exe","-install" )

	; Remove files.
	_SelfDelete()

Else

;    If MsgBox( 4,"Remove " & $LongName & " Service","Are you sure you want to remove " & $LongName & " Service?" & @CRLF & "If you do, no one will be able to connect to you." ) = 6 Then
    If MsgBox( 4,"Remove " & $LongName & " Service","Are you sure you want to remove the " & $LongName & " Service?" ) = 6 Then

		; Allow viewer to disconnect to prevent schook.dll locking.
		MsgBox( 0, "Information", "Please click OK and wait 15 seconds to allow " & $LongName & " to close correctly." & @CRLF & "Any currently connected Remote Support technicians should also close their Viewer now.", 15 )

		; Uninstall service.
		ShellExecute( $ChunkVNCPath & "\" & $ShortName & "Server.exe", "-uninstall" )

		; Wait for Instant Support Server to end.
		ProcessWaitClose( $ShortName & "Server.exe", 10 )

		; Remove files.
		FileDelete( @DesktopCommonDir & '\Uninstall " & $LongName & " Service.lnk"' )
		_SelfDelete()

	EndIf

EndIf

Func _SelfDelete( $iDelay = 5 )
	Local $sCmdFile
	FileDelete( @TempDir & "\scratch.bat" )
	$sCmdFile = 'PING -n ' & $iDelay & ' 127.0.0.1 > nul' & @CRLF _
            & 'DEL /F /Q "' & @ScriptDir & '\cad.exe"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\logo.jpg"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\' & $ShortName & 'Server.exe"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\' & $ShortName & 'ServiceInstaller.exe"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\schook.dll"' & @CRLF _           
			& 'DEL /F /Q "' & @ScriptDir & '\rc4.key"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\MSRC4Plugin.dsm"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\ultravnc.ini"' & @CRLF _
			& 'DEL /F /Q "' & @ScriptDir & '\chunkvnc.ini"' & @CRLF _
			& 'RMDIR /Q "' & @ScriptDir & '"' & @CRLF _   
			& 'DEL "' & @TempDir & '\scratch.bat"'
;			& ':loop' & @CRLF _
;			& 'rmdir "' & @ScriptDir & '" /s /q' & @CRLF _
;			& 'if exist "' & @ScriptFullPath & '" goto loop' & @CRLF _  ; Causes high cpu usage if schook.dll is left behind.
;			& 'del ' & @TempDir & '\scratch.bat'
	FileWrite( @TempDir & "\scratch.bat", $sCmdFile )
	Run( @TempDir & "\scratch.bat", @TempDir, @SW_HIDE )
EndFunc
