#NoTrayIcon
#include "Aut2Exe\Include\ButtonConstants.au3"
#include "Aut2Exe\Include\ComboConstants.au3"
#include "Aut2Exe\Include\GUIConstantsEx.au3"
#include "Aut2Exe\Include\WindowsConstants.au3"
#include "Aut2Exe\Include\GuiComboBox.au3"
#include "Aut2Exe\Include\EditConstants.au3"
#include "Aut2Exe\Include\GuiComboBoxEx.au3"

; include our re-branding info and other global variables
#include 'InstantSupportDefs.au3'


;**************
;  Functions  *
;*******************************************************************************

; Add $Id to head of ID List, avoid duplicate entries
Func AddToList($Id)
	; Remove $Id from list if already present and not at head of list
	$IDList = StringReplace($IDList, '|' & $Id , '')

	; Don't save more than ListMax, keep in mind we assume a 6 digit number.
	If StringLen($IDList) >= ($IDListMax * 6 + ($IDListMax - 1)) Then
		; Maximum ID's in list, trim
		If StringInStr(StringTrimRight($IDList, 7), $Id) = 0 Then $IDList = $Id & "|" & StringTrimRight($IDList, 7)
	Else
		; Maximum ID's not yet reached.
		If $IDList = "" Then
			$IDList = $Id
		Else
			If StringInStr($IDList, $Id) = 0 Then $IDList = $Id & "|" & $IDList
		EndIf
	EndIf
EndFunc


Global $GUI_ENABLE_DEFBUTTON = 576
Global $IDNumber = ""

; Read settings file.
Global $RepeaterAddress = IniRead(@ScriptDir & "\Bin\chunkviewer.ini", "Repeater", "Address", "")
Global $IDList = IniRead(@ScriptDir & "\Bin\chunkviewer.ini", "ChunkViewer", "List", "")
Global $IDListMax = IniRead(@ScriptDir & "\Bin\chunkviewer.ini", "ChunkViewer", "ListMax", "")
Global $Quality = IniRead(@ScriptDir & "\Bin\chunkviewer.ini", "ChunkViewer", "Quality", "")

; Create the GUI.
$Form1 = GUICreate($BrandName & " Remote Viewer", 300, 80, -1, -1)
GUISetBkColor(0xFFFFFF)
$Button1 = GUICtrlCreateButton("Connect", 185, 10, 100, 39)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
GUICtrlSetState($Button1, $GUI_DISABLE)
$Combo1 = GUICtrlCreateCombo("", 15, 11, 155, 25)
GUICtrlSetFont(-1, 20, 800, 0, "MS Sans Serif")
;_GUICtrlComboBox_LimitText($Combo1, 6)	; Limit the number of characters to 6 for input.
$Line1 = GUICtrlCreateLabel("", 0, 60, 300, 1)
GUICtrlSetBkColor(-1, 0x000000)
$Label1 = GUICtrlCreateLabel("", 5, 65, 300, 15)
GUICtrlSetFont($Label1, 8, 400, 0, "MS Sans Serif")


; Create right-click context menu for Combo1.
$ContextMenu1 = GUICtrlCreateContextMenu($Combo1)
$ContextMenuHistory1 = GUICtrlCreateMenuItem("Clear History", $ContextMenu1)
$ContextMenuBlank1 = GUICtrlCreateMenuItem("", $ContextMenu1)
$ContextMenuAbout1 = GUICtrlCreateMenuItem("About", $ContextMenu1)


; Fill Combo1 and show current repeater address.
If $ConnectIdFixed And Not $ConnectId = 0 Then
	AddToList($ConnectId)
EndIf

GUICtrlSetData($Combo1, $IDList)
GUISetState(@SW_SHOW, $Form1)
GUICtrlSetData($Label1, "Using: " & $RepeaterAddress)

; Select first ID in Combo Box's list
_GUICtrlComboBox_SetCurSel($Combo1, 0)


While 1
	; Disable the Connect button if empty, alphabetic characters or incorrect ID format.
	If $IDNumber <> GUICtrlRead($Combo1) Then
		$IDNumber = GUICtrlRead($Combo1)
;		If $IDNumber <> "" And StringIsDigit($IDNumber) = 1 And $IDNumber >= 100000 And $IDNumber <= 999999 Then
		If $IDNumber <> "" And StringIsDigit($IDNumber) = 1 Then
			GUICtrlSetState($Button1, $GUI_ENABLE_DEFBUTTON)
		Else
			GUICtrlSetState($Button1, $GUI_DISABLE)
		EndIf
	EndIf

	$nMsg = GUIGetMsg()

	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

		; Clear history.
		Case $ContextMenuHistory1
			GUICtrlSetData($Label1, "History Cleared.")
			GUICtrlSetData($Combo1, "")
			IniWrite(@ScriptDir & "\Bin\chunkviewer.ini", "ChunkViewer", "List", "")

		; About
		Case $ContextMenuAbout1
			GUICtrlSetData($Label1, $BrandName & " Remote Viewer.")

		Case $Button1
			If $EncryptViewer Then
				; Start Viewer with encryption for Windows
				ShellExecute(@ScriptDir & "\Bin\vncviewer.exe", "-proxy " & $RepeaterAddress & " ID:" & $IDNumber & " -quickoption " & $Quality & " -keepalive 1 -dsmplugin MSRC4Plugin.dsm")
			Else
				; Start Viewer without encryption for Mac
				ShellExecute(@ScriptDir & "\Bin\vncviewer.exe", "-proxy " & $RepeaterAddress & " ID:" & $IDNumber & " -quickoption " & $Quality & " -keepalive 1")
			EndIf

			AddToList($IDNumber)

			; Save IDList in chunkviewer.ini
			IniWrite(@ScriptDir & "\Bin\chunkviewer.ini", "ChunkViewer", "List", $IDList)
			Exit
	EndSwitch
WEnd
